import 'package:flutter/material.dart';

const BASE_SPACING_VALUE = 5.0;

class SuiSpacingValue {
  static const none = BASE_SPACING_VALUE * 0;

  static const small = BASE_SPACING_VALUE / 2;

  static const normal = BASE_SPACING_VALUE;

  static const large = BASE_SPACING_VALUE * 4;

  static const veryLarge = large * 3;

  static const huge = veryLarge * 4;
}

class SuiVerticalSpacing {
  SizedBox get none => SizedBox(height: SuiSpacingValue.none);

  SizedBox get small => SizedBox(height: SuiSpacingValue.small);

  SizedBox get normal => SizedBox(height: SuiSpacingValue.normal);

  SizedBox get large => SizedBox(height: SuiSpacingValue.large);

  SizedBox get veryLarge => SizedBox(height: SuiSpacingValue.veryLarge);

  SizedBox get huge => SizedBox(height: SuiSpacingValue.huge);
}

class SuiHorizontalSpacing {
  SizedBox get none => SizedBox(width: SuiSpacingValue.none);

  SizedBox get small => SizedBox(width: SuiSpacingValue.small);

  SizedBox get normal => SizedBox(width: SuiSpacingValue.normal);

  SizedBox get large => SizedBox(width: SuiSpacingValue.large);

  SizedBox get veryLarge => SizedBox(width: SuiSpacingValue.veryLarge);

  SizedBox get huge => SizedBox(width: SuiSpacingValue.huge);
}
