library sigma_ui;

import 'package:flutter/material.dart';
import 'package:sigma_ui/shared/border_radius.dart';
import 'package:sigma_ui/shared/colors.dart';
import 'package:sigma_ui/shared/padding.dart';
import 'package:sigma_ui/shared/spacing.dart';
import 'package:sigma_ui/shared/text_styles.dart';

export 'shared/colors.dart';
export 'shared/text_styles.dart';
export 'shared/padding.dart';
export 'shared/border_radius.dart';

export 'mixins/sigma_ui_mixin.dart';

export 'widgets/dialogs/sui_dialog.dart';
export 'widgets/buttons/sui_button.dart';
export 'widgets/paddings/sui_padding.dart';
export 'widgets/text_fields/sui_text_field.dart';
export 'widgets/text_fields/sui_dropdown_field.dart';
export 'widgets/text_fields/sui_search_text_field.dart';
export 'widgets/spinners/sui_spinner.dart';
export 'widgets/text/sui_text.dart';
export 'widgets/bottom_navigation_bar/sui_bottom_navigation_bar.dart';
export 'widgets/bottom_navigation_bar/sui_bottom_navigation_bar_item.dart';
export 'widgets/single_child_scroll_view/sui_single_child_scroll_view.dart';
export 'widgets/app_bar/sui_app_bar.dart';
export 'widgets/floating_action_button/sui_floating_action_button.dart';
export 'widgets/filter/sui_frosted_filter.dart';

class SigmaUi {
  SuiBorderRadius get borderRadius => SuiBorderRadius();

  SuiBorderRadiusValue get borderRadiusValue => SuiBorderRadiusValue();

  SuiColor get colors => SuiColor();

  SuiPaddingHelper get padding => SuiPaddingHelper();

  SuiSpacingValue get spacing => SuiSpacingValue();

  SuiVerticalSpacing get verticalSpacing => SuiVerticalSpacing();

  SuiHorizontalSpacing get horizontalSpacing => SuiHorizontalSpacing();

  SuiTextStyle get textStyles => SuiTextStyle();
}

class SigmaUiThemeHelper {
  static isDark(BuildContext context) {
    return Theme.of(context).brightness == Brightness.dark;
  }

  static isLight(BuildContext context) {
    return Theme.of(context).brightness == Brightness.light;
  }
}
