import 'package:flutter/material.dart';

class SuiFloatingActionButton extends StatelessWidget {
  const SuiFloatingActionButton({
    Key? key,
    required this.icon,
    this.onPressed,
    this.backgroundColor,
    this.tooltip,
  }) : super(key: key);

  final VoidCallback? onPressed;
  final Color? backgroundColor;
  final Icon icon;
  final String? tooltip;

  @override
  Widget build(BuildContext context) {
    return FloatingActionButton(
      elevation: 0,
      focusElevation: 0,
      hoverElevation: 0,
      disabledElevation: 0,
      highlightElevation: 0,
      onPressed: onPressed,
      backgroundColor: backgroundColor ?? Theme.of(context).primaryColor,
      child: icon,
      tooltip: tooltip,
    );
  }
}
