import 'package:flutter/material.dart';
import 'package:sigma_ui/sigma_ui.dart';

enum SuiTextType {
  heading1,
  heading2,
  heading3,
  headline,
  body,
  bodyBold,
  bodySmall,
  bodySmallBold,
  subheading,
  caption,
}

class SuiText extends StatelessWidget {
  const SuiText(
    this.text, {
    Key? key,
    this.variant = SuiTextType.body,
    this.style,
    this.textAlign,
    this.overflow,
    this.softWrap,
    this.maxLines,
    this.locale,
    this.semanticsLabel,
    this.textDirection,
    this.strutStyle,
    this.textHeightBehavior,
    this.textScaleFactor,
    this.textWidthBasis,
  }) : super(key: key);

  const SuiText.heading1(
    this.text, {
    Key? key,
    this.variant = SuiTextType.heading1,
    this.style,
    this.textAlign,
    this.overflow,
    this.softWrap,
    this.maxLines,
    this.locale,
    this.semanticsLabel,
    this.textDirection,
    this.strutStyle,
    this.textHeightBehavior,
    this.textScaleFactor,
    this.textWidthBasis,
  }) : super(key: key);

  const SuiText.heading2(
    this.text, {
    Key? key,
    this.variant = SuiTextType.heading2,
    this.style,
    this.textAlign,
    this.overflow,
    this.softWrap,
    this.maxLines,
    this.locale,
    this.semanticsLabel,
    this.textDirection,
    this.strutStyle,
    this.textHeightBehavior,
    this.textScaleFactor,
    this.textWidthBasis,
  }) : super(key: key);

  const SuiText.heading3(
    this.text, {
    Key? key,
    this.variant = SuiTextType.heading3,
    this.style,
    this.textAlign,
    this.overflow,
    this.softWrap,
    this.maxLines,
    this.locale,
    this.semanticsLabel,
    this.textDirection,
    this.strutStyle,
    this.textHeightBehavior,
    this.textScaleFactor,
    this.textWidthBasis,
  }) : super(key: key);

  const SuiText.headline(
    this.text, {
    Key? key,
    this.variant = SuiTextType.headline,
    this.style,
    this.textAlign,
    this.overflow,
    this.softWrap,
    this.maxLines,
    this.locale,
    this.semanticsLabel,
    this.textDirection,
    this.strutStyle,
    this.textHeightBehavior,
    this.textScaleFactor,
    this.textWidthBasis,
  }) : super(key: key);

  const SuiText.body(
    this.text, {
    Key? key,
    this.variant = SuiTextType.body,
    this.style,
    this.textAlign,
    this.overflow,
    this.softWrap,
    this.maxLines,
    this.locale,
    this.semanticsLabel,
    this.textDirection,
    this.strutStyle,
    this.textHeightBehavior,
    this.textScaleFactor,
    this.textWidthBasis,
  }) : super(key: key);

  const SuiText.bodyBold(
    this.text, {
    Key? key,
    this.variant = SuiTextType.bodyBold,
    this.style,
    this.textAlign,
    this.overflow,
    this.softWrap,
    this.maxLines,
    this.locale,
    this.semanticsLabel,
    this.textDirection,
    this.strutStyle,
    this.textHeightBehavior,
    this.textScaleFactor,
    this.textWidthBasis,
  }) : super(key: key);

  const SuiText.bodySmall(
    this.text, {
    Key? key,
    this.variant = SuiTextType.bodySmall,
    this.style,
    this.textAlign,
    this.overflow,
    this.softWrap,
    this.maxLines,
    this.locale,
    this.semanticsLabel,
    this.textDirection,
    this.strutStyle,
    this.textHeightBehavior,
    this.textScaleFactor,
    this.textWidthBasis,
  }) : super(key: key);

  const SuiText.bodySmallBold(
    this.text, {
    Key? key,
    this.variant = SuiTextType.bodySmallBold,
    this.style,
    this.textAlign,
    this.overflow,
    this.softWrap,
    this.maxLines,
    this.locale,
    this.semanticsLabel,
    this.textDirection,
    this.strutStyle,
    this.textHeightBehavior,
    this.textScaleFactor,
    this.textWidthBasis,
  }) : super(key: key);

  const SuiText.subheading(
    this.text, {
    Key? key,
    this.variant = SuiTextType.subheading,
    this.style,
    this.textAlign,
    this.overflow,
    this.softWrap,
    this.maxLines,
    this.locale,
    this.semanticsLabel,
    this.textDirection,
    this.strutStyle,
    this.textHeightBehavior,
    this.textScaleFactor,
    this.textWidthBasis,
  }) : super(key: key);

  const SuiText.caption(
    this.text, {
    Key? key,
    this.variant = SuiTextType.caption,
    this.style,
    this.textAlign,
    this.overflow,
    this.softWrap,
    this.maxLines,
    this.locale,
    this.semanticsLabel,
    this.textDirection,
    this.strutStyle,
    this.textHeightBehavior,
    this.textScaleFactor,
    this.textWidthBasis,
  }) : super(key: key);

  final String text;
  final SuiTextType variant;
  final TextStyle? style;
  final TextAlign? textAlign;
  final TextOverflow? overflow;
  final bool? softWrap;
  final int? maxLines;
  final Locale? locale;
  final String? semanticsLabel;
  final TextDirection? textDirection;
  final StrutStyle? strutStyle;
  final TextHeightBehavior? textHeightBehavior;
  final double? textScaleFactor;
  final TextWidthBasis? textWidthBasis;

  SigmaUi get theme => SigmaUi();

  TextStyle get _style {
    switch (variant) {
      case SuiTextType.heading1:
        return theme.textStyles.heading1;
      case SuiTextType.heading2:
        return theme.textStyles.heading2;
      case SuiTextType.heading3:
        return theme.textStyles.heading3;
      case SuiTextType.headline:
        return theme.textStyles.headline;
      case SuiTextType.body:
        return theme.textStyles.body;
      case SuiTextType.bodyBold:
        return theme.textStyles.bodyBold;
      case SuiTextType.bodySmall:
        return theme.textStyles.bodySmall;
      case SuiTextType.bodySmallBold:
        return theme.textStyles.bodySmallBold;
      case SuiTextType.subheading:
        return theme.textStyles.subheading;
      case SuiTextType.caption:
        return theme.textStyles.caption;
      default:
        return theme.textStyles.body;
    }
  }

  @override
  Widget build(BuildContext context) {
    return Text(
      text,
      key: key,
      style: style ?? _style,
      textAlign: textAlign,
      overflow: overflow,
      softWrap: softWrap,
      maxLines: maxLines,
      locale: locale,
      semanticsLabel: semanticsLabel,
      textDirection: textDirection,
      strutStyle: strutStyle,
      textHeightBehavior: textHeightBehavior,
      textScaleFactor: textScaleFactor,
      textWidthBasis: textWidthBasis,
    );
  }
}
