import 'package:flutter/material.dart';
import 'package:sigma_ui/sigma_ui.dart';

class SuiSearchTextField extends StatefulWidget {
  const SuiSearchTextField({
    Key? key,
    required this.controller,
    required this.focusNode,
    this.onChanged,
    this.label,
  }) : super(key: key);

  final TextEditingController controller;
  final FocusNode focusNode;
  final Function(String?)? onChanged;
  final String? label;

  @override
  _SuiSearchTextFieldState createState() => _SuiSearchTextFieldState();
}

class _SuiSearchTextFieldState extends State<SuiSearchTextField> {
  bool get hasText => widget.controller.text.isNotEmpty;

  @override
  Widget build(BuildContext context) {
    final primaryColor = Theme.of(context).primaryColor;

    return SuiTextField(
      name: 'search',
      label: widget.label ?? 'Search',
      controller: widget.controller,
      focusNode: widget.focusNode,
      suffixIcon: hasText
          ? GestureDetector(
              child: Icon(Icons.close, color: primaryColor),
              onTap: () {
                widget.controller.clear();
                widget.focusNode.unfocus();
              },
            )
          : Icon(
              Icons.search,
              color: primaryColor,
            ),
      onChanged: widget.onChanged,
    );
  }
}
